diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/examples/wireless/wifi-mixed-network.cc ns-3.34/examples/wireless/wifi-mixed-network.cc
--- ns-3.33/examples/wireless/wifi-mixed-network.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/examples/wireless/wifi-mixed-network.cc	2021-07-14 10:31:06.000000000 -0700
@@ -45,9 +45,7 @@
 // - whether short PPDU format is supported by the 802.11b station;
 // - whether short slot time is supported by both the 802.11g station and the AP.
 //
-// The example then compares HT only and mixed HT/non-HT cases with various configurations depending on the following parameters:
-// - whether HT GF is supported by the AP;
-// - whether HT GF is supported by all HT stations;
+// The example then compares HT only and mixed HT/non-HT cases.
 //
 // The output results show that the presence of an 802.11b station strongly affects 802.11g performance.
 // Protection mechanisms ensure that the NAV value of 802.11b stations is set correctly in case of 802.11g transmissions.
@@ -56,8 +54,6 @@
 // mechanism for access points). Since short slot time is disabled once an 802.11b station enters the network, benefits from
 // short slot time are only observed in a g only configuration.
 //
-// HT and mixed-HT results show that HT GF permits to slightly increase performance when all HT stations support GF mode
-//
 // The user can also select the payload size and can choose either an UDP or a TCP connection.
 // Example: ./waf --run "wifi-mixed-network --isUdp=1"
 
@@ -73,15 +69,12 @@
   bool enableShortSlotTime;
   bool enableShortPhyPreamble;
   WifiStandard apType;
-  bool apSupportsGreenfield;
   uint32_t nWifiB;
   bool bHasTraffic;
   uint32_t nWifiG;
   bool gHasTraffic;
-  uint32_t nWifiNNonGreenfield;
-  bool nNonGreenfieldHasTraffic;
-  uint32_t nWifiNGreenfield;
-  bool nGreenfieldHasTraffic;
+  uint32_t nWifiN;
+  bool nHasTraffic;
   bool isUdp;
   uint32_t payloadSize;
   double simulationTime;
@@ -117,15 +110,12 @@
             << "\n\t enableShortSlotTime=" << params.enableShortSlotTime
             << "\n\t enableShortPhyPreamble=" << params.enableShortPhyPreamble
             << "\n\t apType=" << apTypeString
-            << "\n\t apSupportsGreenfield=" << params.apSupportsGreenfield
             << "\n\t nWifiB=" << params.nWifiB
             << "\n\t bHasTraffic=" << params.bHasTraffic
             << "\n\t nWifiG=" << params.nWifiG
             << "\n\t gHasTraffic=" << params.gHasTraffic
-            << "\n\t nWifiNNonGreenfield=" << params.nWifiNNonGreenfield
-            << "\n\t nNonGreenfieldHasTraffic=" << params.nNonGreenfieldHasTraffic
-            << "\n\t nWifiNGreenfield=" << params.nWifiNGreenfield
-            << "\n\t nGreenfieldHasTraffic=" << params.nGreenfieldHasTraffic
+            << "\n\t nWifiN=" << params.nWifiN
+            << "\n\t nHasTraffic=" << params.nHasTraffic
             << std::endl;
 
   Config::SetDefault ("ns3::WifiRemoteStationManager::ErpProtectionMode", StringValue (params.erpProtectionMode));
@@ -133,8 +123,7 @@
   double throughput = 0;
   uint32_t nWifiB = params.nWifiB;
   uint32_t nWifiG = params.nWifiG;
-  uint32_t nWifiNNGF = params.nWifiNNonGreenfield;
-  uint32_t nWifiNGF = params.nWifiNGreenfield;
+  uint32_t nWifiN = params.nWifiN;
   double simulationTime = params.simulationTime;
   uint32_t payloadSize = params.payloadSize;
 
@@ -142,10 +131,8 @@
   wifiBStaNodes.Create (nWifiB);
   NodeContainer wifiGStaNodes;
   wifiGStaNodes.Create (nWifiG);
-  NodeContainer wifiNNGFStaNodes;
-  wifiNNGFStaNodes.Create (nWifiNNGF);
-  NodeContainer wifiNGFStaNodes;
-  wifiNGFStaNodes.Create (nWifiNGF);
+  NodeContainer wifiNStaNodes;
+  wifiNStaNodes.Create (nWifiN);
   NodeContainer wifiApNode;
   wifiApNode.Create (1);
 
@@ -153,7 +140,6 @@
   channel.AddPropagationLoss ("ns3::RangePropagationLossModel");
 
   YansWifiPhyHelper phy;
-  phy.SetPcapDataLinkType (WifiPhyHelper::DLT_IEEE802_11_RADIO);
   phy.SetChannel (channel.Create ());
 
   WifiHelper wifi;
@@ -182,13 +168,12 @@
 
   // 802.11b/g/n STA
   wifi.SetStandard (WIFI_STANDARD_80211n_2_4GHZ);
-  NetDeviceContainer nNGFStaDevice, nGFStaDevice;
+  NetDeviceContainer nStaDevice;
   mac.SetType ("ns3::StaWifiMac",
                "Ssid", SsidValue (ssid),
                "BE_BlockAckThreshold", UintegerValue (2),
                "ShortSlotTimeSupported", BooleanValue (params.enableShortSlotTime));
-  nNGFStaDevice = wifi.Install (phy, mac, wifiNNGFStaNodes);
-  nGFStaDevice = wifi.Install (phy, mac, wifiNGFStaNodes);
+  nStaDevice = wifi.Install (phy, mac, wifiNStaNodes);
 
   // AP
   NetDeviceContainer apDevice;
@@ -206,31 +191,16 @@
     {
       Ptr<NetDevice> dev = wifiApNode.Get (0)->GetDevice (0);
       Ptr<WifiNetDevice> wifi_dev = DynamicCast<WifiNetDevice> (dev);
-      Ptr<HtConfiguration> htConfiguration = wifi_dev->GetHtConfiguration ();
-      htConfiguration->SetGreenfieldSupported (params.apSupportsGreenfield);
-      Ptr<WifiMac> wifi_mac = wifi_dev->GetMac ();
-      PointerValue ptr;
-      wifi_mac->GetAttribute ("BE_Txop", ptr);
-      Ptr<QosTxop> edca = ptr.Get<QosTxop> ();
-      edca->SetTxopLimit (MicroSeconds (3008));
-    }
-  if (nWifiNNGF > 0)
-    {
-      Ptr<NetDevice> dev = wifiNNGFStaNodes.Get (0)->GetDevice (0);
-      Ptr<WifiNetDevice> wifi_dev = DynamicCast<WifiNetDevice> (dev);
-      Ptr<HtConfiguration> htConfiguration = wifi_dev->GetHtConfiguration ();
       Ptr<WifiMac> wifi_mac = wifi_dev->GetMac ();
       PointerValue ptr;
       wifi_mac->GetAttribute ("BE_Txop", ptr);
       Ptr<QosTxop> edca = ptr.Get<QosTxop> ();
       edca->SetTxopLimit (MicroSeconds (3008));
     }
-  if (nWifiNGF > 0)
+  if (nWifiN > 0)
     {
-      Ptr<NetDevice> dev = wifiNGFStaNodes.Get (0)->GetDevice (0);
+      Ptr<NetDevice> dev = wifiNStaNodes.Get (0)->GetDevice (0);
       Ptr<WifiNetDevice> wifi_dev = DynamicCast<WifiNetDevice> (dev);
-      Ptr<HtConfiguration> htConfiguration = wifi_dev->GetHtConfiguration ();
-      htConfiguration->SetGreenfieldSupported (true);
       Ptr<WifiMac> wifi_mac = wifi_dev->GetMac ();
       PointerValue ptr;
       wifi_mac->GetAttribute ("BE_Txop", ptr);
@@ -253,11 +223,7 @@
     {
       positionAlloc->Add (Vector (0.0, 5.0, 0.0));
     }
-  for (uint32_t i = 0; i < nWifiNNGF; i++)
-    {
-      positionAlloc->Add (Vector (0.0, 0.0, 5.0));
-    }
-  for (uint32_t i = 0; i < nWifiNGF; i++)
+  for (uint32_t i = 0; i < nWifiN; i++)
     {
       positionAlloc->Add (Vector (0.0, 0.0, 5.0));
     }
@@ -267,16 +233,14 @@
   mobility.Install (wifiApNode);
   mobility.Install (wifiBStaNodes);
   mobility.Install (wifiGStaNodes);
-  mobility.Install (wifiNNGFStaNodes);
-  mobility.Install (wifiNGFStaNodes);
+  mobility.Install (wifiNStaNodes);
 
   // Internet stack
   InternetStackHelper stack;
   stack.Install (wifiApNode);
   stack.Install (wifiBStaNodes);
   stack.Install (wifiGStaNodes);
-  stack.Install (wifiNNGFStaNodes);
-  stack.Install (wifiNGFStaNodes);
+  stack.Install (wifiNStaNodes);
 
   Ipv4AddressHelper address;
   address.SetBase ("192.168.1.0", "255.255.255.0");
@@ -284,10 +248,8 @@
   bStaInterface = address.Assign (bStaDevice);
   Ipv4InterfaceContainer gStaInterface;
   gStaInterface = address.Assign (gStaDevice);
-  Ipv4InterfaceContainer nNGFStaInterface;
-  nNGFStaInterface = address.Assign (nNGFStaDevice);
-  Ipv4InterfaceContainer nGFStaInterface;
-  nGFStaInterface = address.Assign (nGFStaDevice);
+  Ipv4InterfaceContainer nStaInterface;
+  nStaInterface = address.Assign (nStaDevice);
   Ipv4InterfaceContainer ApInterface;
   ApInterface = address.Assign (apDevice);
 
@@ -314,13 +276,9 @@
         {
           clientApps.Add (client.Install (wifiGStaNodes));
         }
-      if (params.nNonGreenfieldHasTraffic)
+      if (params.nHasTraffic)
         {
-          clientApps.Add (client.Install (wifiNNGFStaNodes));
-        }
-      if (params.nGreenfieldHasTraffic)
-        {
-          clientApps.Add (client.Install (wifiNGFStaNodes));
+          clientApps.Add (client.Install (wifiNStaNodes));
         }
       clientApps.Start (Seconds (1.0));
       clientApps.Stop (Seconds (simulationTime + 1));
@@ -359,13 +317,9 @@
         {
           clientApps.Add (onoff.Install (wifiGStaNodes));
         }
-      if (params.nNonGreenfieldHasTraffic)
-        {
-          clientApps.Add (onoff.Install (wifiNNGFStaNodes));
-        }
-      if (params.nGreenfieldHasTraffic)
+      if (params.nHasTraffic)
         {
-          clientApps.Add (onoff.Install (wifiNGFStaNodes));
+          clientApps.Add (onoff.Install (wifiNStaNodes));
         }
       clientApps.Start (Seconds (1.0));
       clientApps.Stop (Seconds (simulationTime + 1));
@@ -389,15 +343,12 @@
   params.enableShortSlotTime = false;
   params.enableShortPhyPreamble = false;
   params.apType = WIFI_STANDARD_80211g;
-  params.apSupportsGreenfield = false;
   params.nWifiB = 0;
   params.bHasTraffic = false;
   params.nWifiG = 1;
   params.gHasTraffic = true;
-  params.nWifiNNonGreenfield = 0;
-  params.nNonGreenfieldHasTraffic = false;
-  params.nWifiNGreenfield = 0;
-  params.nGreenfieldHasTraffic = false;
+  params.nWifiN = 0;
+  params.nHasTraffic = false;
   params.isUdp = true;
   params.payloadSize = 1472; //bytes
   params.simulationTime = 10; //seconds
@@ -516,130 +467,17 @@
     }
   std::cout << "Throughput: " << throughput << " Mbit/s \n" << std::endl;
 
-  params.testName = "HT GF not supported";
-  params.enableErpProtection = false;
-  params.enableShortSlotTime = false;
-  params.enableShortPhyPreamble = false;
-  params.apType = WIFI_STANDARD_80211n_2_4GHZ;
-  params.apSupportsGreenfield = false;
-  params.nWifiB = 0;
-  params.bHasTraffic = false;
-  params.nWifiG = 0;
-  params.gHasTraffic = false;
-  params.nWifiNNonGreenfield = 1;
-  params.nNonGreenfieldHasTraffic = true;
-  params.nWifiNGreenfield = 0;
-  params.nGreenfieldHasTraffic = false;
-  throughput = experiment.Run (params);
-  if (verifyResults && (throughput < 43 || throughput > 44))
-    {
-      NS_LOG_ERROR ("Obtained throughput " << throughput << " is not in the expected boundaries!");
-      exit (1);
-    }
-  std::cout << "Throughput: " << throughput << " Mbit/s \n" << std::endl;
-
-  params.testName = "HT only with GF used";
-  params.enableErpProtection = false;
-  params.enableShortSlotTime = false;
-  params.enableShortPhyPreamble = false;
-  params.apType = WIFI_STANDARD_80211n_2_4GHZ;
-  params.apSupportsGreenfield = true;
-  params.nWifiB = 0;
-  params.bHasTraffic = false;
-  params.nWifiG = 0;
-  params.gHasTraffic = false;
-  params.nWifiNNonGreenfield = 0;
-  params.nNonGreenfieldHasTraffic = false;
-  params.nWifiNGreenfield = 1;
-  params.nGreenfieldHasTraffic = true;
-  throughput = experiment.Run (params);
-  if (verifyResults && (throughput < 44 || throughput > 45))
-    {
-      NS_LOG_ERROR ("Obtained throughput " << throughput << " is not in the expected boundaries!");
-      exit (1);
-    }
-  std::cout << "Throughput: " << throughput << " Mbit/s \n" << std::endl;
-
-  params.testName = "HT only with GF allowed but disabled by protection";
-  params.enableErpProtection = false;
-  params.enableShortSlotTime = false;
-  params.enableShortPhyPreamble = false;
-  params.apType = WIFI_STANDARD_80211n_2_4GHZ;
-  params.apSupportsGreenfield = true;
-  params.nWifiB = 0;
-  params.bHasTraffic = false;
-  params.nWifiG = 0;
-  params.gHasTraffic = false;
-  params.nWifiNNonGreenfield = 1;
-  params.nNonGreenfieldHasTraffic = false;
-  params.nWifiNGreenfield = 1;
-  params.nGreenfieldHasTraffic = true;
-  throughput = experiment.Run (params);
-  if (verifyResults && (throughput < 43 || throughput > 44))
-    {
-      NS_LOG_ERROR ("Obtained throughput " << throughput << " is not in the expected boundaries!");
-      exit (1);
-    }
-  std::cout << "Throughput: " << throughput << " Mbit/s \n" << std::endl;
-
-  params.testName = "HT only with GF not supported by the receiver";
-  params.enableErpProtection = false;
-  params.enableShortSlotTime = false;
-  params.enableShortPhyPreamble = false;
-  params.apType = WIFI_STANDARD_80211n_2_4GHZ;
-  params.apSupportsGreenfield = false;
-  params.nWifiB = 0;
-  params.bHasTraffic = false;
-  params.nWifiG = 0;
-  params.gHasTraffic = false;
-  params.nWifiNNonGreenfield = 0;
-  params.nNonGreenfieldHasTraffic = false;
-  params.nWifiNGreenfield = 1;
-  params.nGreenfieldHasTraffic = true;
-  throughput = experiment.Run (params);
-  if (verifyResults && (throughput < 43 || throughput > 44))
-    {
-      NS_LOG_ERROR ("Obtained throughput " << throughput << " is not in the expected boundaries!");
-      exit (1);
-    }
-  std::cout << "Throughput: " << throughput << " Mbit/s \n" << std::endl;
-
-  params.testName = "Mixed HT/non-HT with GF enabled";
-  params.enableErpProtection = false;
-  params.enableShortSlotTime = false;
-  params.enableShortPhyPreamble = false;
-  params.apType = WIFI_STANDARD_80211n_2_4GHZ;
-  params.apSupportsGreenfield = true;
-  params.nWifiB = 0;
-  params.bHasTraffic = false;
-  params.nWifiG = 1;
-  params.gHasTraffic = false;
-  params.nWifiNNonGreenfield = 0;
-  params.nNonGreenfieldHasTraffic = false;
-  params.nWifiNGreenfield = 1;
-  params.nGreenfieldHasTraffic = true;
-  throughput = experiment.Run (params);
-  if (verifyResults && (throughput < 44 || throughput > 45))
-    {
-      NS_LOG_ERROR ("Obtained throughput " << throughput << " is not in the expected boundaries!");
-      exit (1);
-    }
-  std::cout << "Throughput: " << throughput << " Mbit/s \n" << std::endl;
-
   params.testName = "HT only";
   params.enableErpProtection = false;
   params.enableShortSlotTime = false;
   params.enableShortPhyPreamble = false;
   params.apType = WIFI_STANDARD_80211n_2_4GHZ;
-  params.apSupportsGreenfield = false;
   params.nWifiB = 0;
   params.bHasTraffic = false;
   params.nWifiG = 0;
   params.gHasTraffic = false;
-  params.nWifiNNonGreenfield = 1;
-  params.nNonGreenfieldHasTraffic = true;
-  params.nWifiNGreenfield = 0;
-  params.nGreenfieldHasTraffic = false;
+  params.nWifiN = 1;
+  params.nHasTraffic = true;
   throughput = experiment.Run (params);
   if (verifyResults && (throughput < 44 || throughput > 45))
     {
@@ -653,15 +491,12 @@
   params.enableShortSlotTime = false;
   params.enableShortPhyPreamble = false;
   params.apType = WIFI_STANDARD_80211n_2_4GHZ;
-  params.apSupportsGreenfield = false;
   params.nWifiB = 0;
   params.bHasTraffic = false;
   params.nWifiG = 1;
   params.gHasTraffic = false;
-  params.nWifiNNonGreenfield = 1;
-  params.nNonGreenfieldHasTraffic = true;
-  params.nWifiNGreenfield = 0;
-  params.nGreenfieldHasTraffic = false;
+  params.nWifiN = 1;
+  params.nHasTraffic = true;
   throughput = experiment.Run (params);
   if (verifyResults && (throughput < 44 || throughput > 45))
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/examples/wireless/wifi-multirate.cc ns-3.34/examples/wireless/wifi-multirate.cc
--- ns-3.33/examples/wireless/wifi-multirate.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/examples/wireless/wifi-multirate.cc	2021-07-14 10:31:06.000000000 -0700
@@ -521,6 +521,7 @@
 
   if (enablePcap)
     {
+      phy.SetPcapDataLinkType (WifiPhyHelper::DLT_IEEE802_11_RADIO);
       phy.EnablePcapAll (GetOutputFileName ());
     }
 
@@ -601,7 +602,7 @@
 
   wifiMac.SetType ("ns3::AdhocWifiMac",
                    "Ssid", StringValue ("Testbed"));
-  wifi.SetStandard (WIFI_STANDARD_holland);
+  wifi.SetStandard (WIFI_STANDARD_80211a);
   wifi.SetRemoteStationManager (experiment.GetRateManager ());
 
   NS_LOG_INFO ("Scenario: " << experiment.GetScenario ());
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/examples/wireless/wifi-power-adaptation-distance.cc ns-3.34/examples/wireless/wifi-power-adaptation-distance.cc
--- ns-3.33/examples/wireless/wifi-power-adaptation-distance.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/examples/wireless/wifi-power-adaptation-distance.cc	2021-07-14 10:31:06.000000000 -0700
@@ -152,7 +152,7 @@
   Ptr<WifiPhy> phy = wifiDevice->GetPhy ();
   myPhy = phy;
   SetupPhy (phy);
-  DataRate dataRate = DataRate (phy->GetMode (0).GetDataRate (phy->GetChannelWidth ()));
+  DataRate dataRate = DataRate (phy->GetDefaultMode ().GetDataRate (phy->GetChannelWidth ()));
   double power = phy->GetTxPowerEnd ();
   for (uint32_t j = 0; j < stas.GetN (); j++)
     {
@@ -173,17 +173,15 @@
 void
 NodeStatistics::SetupPhy (Ptr<WifiPhy> phy)
 {
-  uint32_t nModes = phy->GetNModes ();
-  for (uint32_t i = 0; i < nModes; i++)
+  for (const auto & mode : phy->GetModeList ())
     {
-      WifiMode mode = phy->GetMode (i);
       WifiTxVector txVector;
       txVector.SetMode (mode);
       txVector.SetPreambleType (WIFI_PREAMBLE_LONG);
       txVector.SetChannelWidth (phy->GetChannelWidth ());
       DataRate dataRate = DataRate (mode.GetDataRate (phy->GetChannelWidth ()));
       Time time = phy->CalculateTxDuration (packetSize, txVector, phy->GetPhyBand ());
-      NS_LOG_DEBUG (i << " " << time.GetSeconds () << " " << dataRate);
+      NS_LOG_DEBUG (mode.GetUniqueName () << " " << time.GetSeconds () << " " << dataRate);
       timeTable.push_back (std::make_pair (time, dataRate));
     }
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/examples/wireless/wifi-power-adaptation-interference.cc ns-3.34/examples/wireless/wifi-power-adaptation-interference.cc
--- ns-3.33/examples/wireless/wifi-power-adaptation-interference.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/examples/wireless/wifi-power-adaptation-interference.cc	2021-07-14 10:31:06.000000000 -0700
@@ -140,7 +140,7 @@
   Ptr<WifiPhy> phy = wifiDevice->GetPhy ();
   myPhy = phy;
   SetupPhy (phy);
-  DataRate dataRate = DataRate (phy->GetMode (0).GetDataRate (phy->GetChannelWidth ()));
+  DataRate dataRate = DataRate (phy->GetDefaultMode ().GetDataRate (phy->GetChannelWidth ()));
   double power = phy->GetTxPowerEnd ();
   for (uint32_t j = 0; j < stas.GetN (); j++)
     {
@@ -172,17 +172,15 @@
 void
 NodeStatistics::SetupPhy (Ptr<WifiPhy> phy)
 {
-  uint32_t nModes = phy->GetNModes ();
-  for (uint32_t i = 0; i < nModes; i++)
+  for (const auto & mode : phy->GetModeList ())
     {
-      WifiMode mode = phy->GetMode (i);
       WifiTxVector txVector;
       txVector.SetMode (mode);
       txVector.SetPreambleType (WIFI_PREAMBLE_LONG);
       txVector.SetChannelWidth (phy->GetChannelWidth ());
       DataRate dataRate = DataRate (mode.GetDataRate (phy->GetChannelWidth ()));
       Time time = phy->CalculateTxDuration (packetSize, txVector, phy->GetPhyBand ());
-      NS_LOG_DEBUG (i << " " << time.GetSeconds () << " " << dataRate);
+      NS_LOG_DEBUG (mode.GetUniqueName () << " " << time.GetSeconds () << " " << dataRate);
       timeTable.push_back (std::make_pair (time, dataRate));
     }
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/examples/wireless/wifi-sleep.cc ns-3.34/examples/wireless/wifi-sleep.cc
--- ns-3.33/examples/wireless/wifi-sleep.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/examples/wireless/wifi-sleep.cc	2021-07-14 10:31:06.000000000 -0700
@@ -130,9 +130,6 @@
   wifi.SetStandard (WIFI_STANDARD_80211b);
 
   YansWifiPhyHelper wifiPhy;
-  // ns-3 supports RadioTap and Prism tracing extensions for 802.11b
-  wifiPhy.SetPcapDataLinkType (WifiPhyHelper::DLT_IEEE802_11_RADIO);
-
   wifiPhy.Set ("TxPowerStart", DoubleValue (txPowerStart));
   wifiPhy.Set ("TxPowerEnd", DoubleValue (txPowerEnd));
   wifiPhy.Set ("TxPowerLevels", UintegerValue (nTxPowerLevels));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/examples/wireless/wifi-spectrum-per-example.cc ns-3.34/examples/wireless/wifi-spectrum-per-example.cc
--- ns-3.33/examples/wireless/wifi-spectrum-per-example.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/examples/wireless/wifi-spectrum-per-example.cc	2021-07-14 10:31:06.000000000 -0700
@@ -180,7 +180,6 @@
           phy.SetChannel (channel.Create ());
           phy.Set ("TxPowerStart", DoubleValue (1)); // dBm (1.26 mW)
           phy.Set ("TxPowerEnd", DoubleValue (1));
-          phy.Set ("Frequency", UintegerValue (5180));
         }
       else if (wifiType == "ns3::SpectrumWifiPhy")
         {
@@ -197,7 +196,6 @@
 
           spectrumPhy.SetChannel (spectrumChannel);
           spectrumPhy.SetErrorRateModel (errorModelType);
-          spectrumPhy.Set ("Frequency", UintegerValue (5180));
           spectrumPhy.Set ("TxPowerStart", DoubleValue (1)); // dBm  (1.26 mW)
           spectrumPhy.Set ("TxPowerEnd", DoubleValue (1));
         }
@@ -386,9 +384,11 @@
         {
           mac.SetType ("ns3::StaWifiMac",
                        "Ssid", SsidValue (ssid));
+          phy.Set ("ChannelWidth", UintegerValue (i <= 15 ? 20 : 40));
           staDevice = wifi.Install (phy, mac, wifiStaNode);
           mac.SetType ("ns3::ApWifiMac",
                        "Ssid", SsidValue (ssid));
+          phy.Set ("ChannelWidth", UintegerValue (i <= 15 ? 20 : 40));
           apDevice = wifi.Install (phy, mac, wifiApNode);
 
         }
@@ -396,30 +396,28 @@
         {
           mac.SetType ("ns3::StaWifiMac",
                        "Ssid", SsidValue (ssid));
+          phy.Set ("ChannelWidth", UintegerValue (i <= 15 ? 20 : 40));
           staDevice = wifi.Install (spectrumPhy, mac, wifiStaNode);
           mac.SetType ("ns3::ApWifiMac",
                        "Ssid", SsidValue (ssid));
+          phy.Set ("ChannelWidth", UintegerValue (i <= 15 ? 20 : 40));
           apDevice = wifi.Install (spectrumPhy, mac, wifiApNode);
         }
 
       if (i <= 7)
         {
-          Config::Set ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Phy/ChannelWidth", UintegerValue (20));
           Config::Set ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/ShortGuardIntervalSupported", BooleanValue (false));
         }
       else if (i > 7 && i <= 15)
         {
-          Config::Set ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Phy/ChannelWidth", UintegerValue (20));
           Config::Set ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/ShortGuardIntervalSupported", BooleanValue (true));
         }
       else if (i > 15 && i <= 23)
         {
-          Config::Set ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Phy/ChannelWidth", UintegerValue (40));
           Config::Set ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/ShortGuardIntervalSupported", BooleanValue (false));
         }
       else
         {
-          Config::Set ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Phy/ChannelWidth", UintegerValue (40));
           Config::Set ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/ShortGuardIntervalSupported", BooleanValue (true));
         }
 
@@ -494,6 +492,7 @@
 
       if (enablePcap)
         {
+          phy.SetPcapDataLinkType (WifiPhyHelper::DLT_IEEE802_11_RADIO);
           std::stringstream ss;
           ss << "wifi-spectrum-per-example-" << i;
           phy.EnablePcap (ss.str (), apDevice);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/examples/wireless/wifi-spectrum-per-interference.cc ns-3.34/examples/wireless/wifi-spectrum-per-interference.cc
--- ns-3.33/examples/wireless/wifi-spectrum-per-interference.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/examples/wireless/wifi-spectrum-per-interference.cc	2021-07-14 10:31:06.000000000 -0700
@@ -118,7 +118,7 @@
 
 NS_LOG_COMPONENT_DEFINE ("WifiSpectrumPerInterference");
 
-Ptr<SpectrumModel> SpectrumModelWifi5180MHz;
+Ptr<SpectrumModel> SpectrumModelWifi5180MHz, SpectrumModelWifi5190MHz;
 
 class static_SpectrumModelWifi5180MHz_initializer
 {
@@ -138,6 +138,24 @@
 
 } static_SpectrumModelWifi5180MHz_initializer_instance;
 
+class static_SpectrumModelWifi5190MHz_initializer
+{
+public:
+  static_SpectrumModelWifi5190MHz_initializer ()
+  {
+    BandInfo bandInfo;
+    bandInfo.fc = 5190e6;
+    bandInfo.fl = 5190e6 - 10e6;
+    bandInfo.fh = 5190e6 + 10e6;
+
+    Bands bands;
+    bands.push_back (bandInfo);
+
+    SpectrumModelWifi5190MHz = Create<SpectrumModel> (bands);
+  }
+
+} static_SpectrumModelWifi5190MHz_initializer_instance;
+
 int main (int argc, char *argv[])
 {
   bool udp = true;
@@ -202,14 +220,15 @@
       YansWifiPhyHelper phy;
       SpectrumWifiPhyHelper spectrumPhy;
       Ptr<MultiModelSpectrumChannel> spectrumChannel;
+      uint16_t frequency = (i <= 15 ? 5180 : 5190);
       if (wifiType == "ns3::YansWifiPhy")
         {
           YansWifiChannelHelper channel;
           channel.AddPropagationLoss ("ns3::FriisPropagationLossModel",
-                                      "Frequency", DoubleValue (5.180e9));
+                                      "Frequency", DoubleValue (frequency * 1e6));
           channel.SetPropagationDelay ("ns3::ConstantSpeedPropagationDelayModel");
           phy.SetChannel (channel.Create ());
-          phy.Set ("Frequency", UintegerValue (5180));
+          phy.Set ("Frequency", UintegerValue (frequency));
         }
       else if (wifiType == "ns3::SpectrumWifiPhy")
         {
@@ -217,7 +236,7 @@
             = CreateObject<MultiModelSpectrumChannel> ();
           Ptr<FriisPropagationLossModel> lossModel
             = CreateObject<FriisPropagationLossModel> ();
-          lossModel->SetFrequency (5.180e9);
+          lossModel->SetFrequency (frequency * 1e6);
           spectrumChannel->AddPropagationLossModel (lossModel);
 
           Ptr<ConstantSpeedPropagationDelayModel> delayModel
@@ -226,7 +245,7 @@
 
           spectrumPhy.SetChannel (spectrumChannel);
           spectrumPhy.SetErrorRateModel (errorModelType);
-          spectrumPhy.Set ("Frequency", UintegerValue (5180)); // channel 36 at 20 MHz
+          spectrumPhy.Set ("Frequency", UintegerValue (frequency)); // channel 36 at 20 MHz, 38 at 40 MHz
         }
       else
         {
@@ -430,22 +449,18 @@
 
       if (i <= 7)
         {
-          Config::Set ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Phy/ChannelWidth", UintegerValue (20));
           Config::Set ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/ShortGuardIntervalSupported", BooleanValue (false));
         }
       else if (i > 7 && i <= 15)
         {
-          Config::Set ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Phy/ChannelWidth", UintegerValue (20));
           Config::Set ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/ShortGuardIntervalSupported", BooleanValue (true));
         }
       else if (i > 15 && i <= 23)
         {
-          Config::Set ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Phy/ChannelWidth", UintegerValue (40));
           Config::Set ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/ShortGuardIntervalSupported", BooleanValue (false));
         }
       else
         {
-          Config::Set ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Phy/ChannelWidth", UintegerValue (40));
           Config::Set ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/ShortGuardIntervalSupported", BooleanValue (true));
         }
 
@@ -519,7 +534,8 @@
         }
 
       // Configure waveform generator
-      Ptr<SpectrumValue> wgPsd = Create<SpectrumValue> (SpectrumModelWifi5180MHz);
+      Ptr<SpectrumValue> wgPsd = Create<SpectrumValue> (i <= 15 ? SpectrumModelWifi5180MHz
+                                                                : SpectrumModelWifi5190MHz);
       *wgPsd = waveformPower / 20e6;  // PSD spread across 20 MHz
       NS_LOG_INFO ("wgPsd : " << *wgPsd << " integrated power: " << Integral (*(GetPointer (wgPsd))));
 
@@ -541,6 +557,7 @@
 
       if (enablePcap)
         {
+          phy.SetPcapDataLinkType (WifiPhyHelper::DLT_IEEE802_11_RADIO);
           std::stringstream ss;
           ss << "wifi-spectrum-per-example-" << i;
           phy.EnablePcap (ss.str (), apDevice);
@@ -552,12 +569,20 @@
       // Make sure we are tuned to 5180 MHz; if not, the example will
       // not work properly
       Ptr<NetDevice> staDevicePtr = staDevice.Get (0);
-      Ptr<WifiNetDevice> wifiStaDevicePtr = staDevicePtr->GetObject <WifiNetDevice> ();
-      UintegerValue val;
-      wifiStaDevicePtr->GetPhy ()->GetAttribute ("Frequency", val);
-      if (val.Get () != 5180)
+      Ptr<WifiPhy> wifiPhyPtr = staDevicePtr->GetObject <WifiNetDevice> ()->GetPhy ();
+      if (i <= 15)
+        {
+          NS_ABORT_MSG_IF (wifiPhyPtr->GetChannelWidth () != 20,
+                           "Error: Channel width must be 20 MHz if MCS index <= 15");
+          NS_ABORT_MSG_IF (wifiPhyPtr->GetFrequency () != 5180,
+                           "Error:  Wi-Fi nodes must be tuned to 5180 MHz to match the waveform generator");
+        }
+      else
         {
-          NS_FATAL_ERROR ("Error:  Wi-Fi nodes must be tuned to 5180 MHz to match the waveform generator");
+          NS_ABORT_MSG_IF (wifiPhyPtr->GetChannelWidth () != 40,
+                           "Error: Channel width must be 40 MHz if MCS index > 15");
+          NS_ABORT_MSG_IF (wifiPhyPtr->GetFrequency () != 5190,
+                           "Error:  Wi-Fi nodes must be tuned to 5190 MHz to match the waveform generator");
         }
 
       Simulator::Stop (Seconds (simulationTime + 1));
